/*    mail.js								//gW 
 * 
 * 2008-08-04  Open Msg with msgID also with FX (non-mail apps)
 * 2008-04-14	tagging	- add/delete 'ical-*' tags for messages containing 
 * 									iCal data
 * 2006-11-11	mod for TB1.5/label and TB2.0/tag
 * 2008-01-19	add TB-priority handling
 *
 * ............................................................... 
 * based on 
 *    MessageID-Finder for Mozilla 'messageidfinder-2.0.0.xpi' by markushossner aT gmx DOT de and 
 *    'reminderfox-0.9.6.xpi' by Daniel Lee, Tom Mutdosch
 */
 
var rmFx_currentSummary = null;
var rmFx_ReferenceID = "@" + "reminderfox" 
var rmFx_FCC ="";
var rmFx_cmdID = null;
var rmFx_cmdString = "";

//  Work with rmFx_cmdLineHandler to support starting Thunderbird 
//  with start option:
//     thunderbird.exe -reminderFox {messageID}


function rmFx_startupwMsgId() {
	var startMsg	= window.arguments[0].split("|.|");
	rmFx_cmdID 		= startMsg[0];
	rmFx_cmdString	= startMsg[1];

		var cDate = new Date();
		var msgLog = " ** Remote access **  " + rmFx_cmdID + " at: " + cDate;
		rmFxUtil.setStatus(msgLog);
				
	if (rmFx_cmdID.indexOf('UID:') > -1) {
		// -reminderFox UID:refID -msgString mailFile.persistentDescriptor

		document.title = "Remote send message";	// reminderFox_getBundle().getString("rf.mail.remote.sendmsg");

		document.getElementById('rmFx_msg1')
					.setAttribute("value", rmFx_cmdID);  
		document.getElementById('rmFx_msg2')
					.setAttribute("value", "");    // rmFx_cmdString);  
	   setTimeout( rmFxMsg.sendwUIDgo, 1000 );
	   		
	} else  if (rmFx_cmdID.indexOf('COMPOSE:') > -1) {
		// -reminderFox UID:refID -msgString msgString
		
		document.title = "Remote compose message";  // reminderFox_getBundle().getString("rf.mail.remote.composemsg"); 

		var msgString = unescape(rmFx_cmdString).split(";\n;");
		var subject       = msgString[0].substring(8);

		document.getElementById('rmFx_msg1')
					.setAttribute("value", "Subject: " + subject);
		document.getElementById('rmFx_msg2')
					.setAttribute("value", "");

	   setTimeout( rmFxMsg.composeMSGgo, 1000 );
		   
	} else  if (rmFx_cmdID.indexOf('msgID:') > -1) {
		// -reminderFox msgID:finalMessageId -msgString escape(rmFx_currentSummary)

		document.title = "Remote open message";	//	reminderFox_getBundle().getString("rf.mail.remote.openmsg");

		document.getElementById('rmFx_msg1')
					.setAttribute("value", unescape(rmFx_cmdString));
		document.getElementById('rmFx_msg2')
					.setAttribute("value", rmFx_cmdID);
	   setTimeout( rmFx_retryMsgIdDelayed, 1000 );
	} else {
		
		alert ("reminderFox call error!")
		return;
	}
}

/////////////////////// find message with MsgID ////////////////////////////////

function rmFx_retryMsgIdDelayed() {
	//'UID:'
	//var reminderID = rmFx_cmdID.substring(4);
	//'msgID:'
	
    var msgHdr = reminderFox_MessageIdFinder(rmFx_cmdID.substring(6));
    if (msgHdr) {
        window.close();
    }   
    else  {  // 'reminderFox_MessageIdFinder' with TB startup will fail because
             //  folder structure not build already
             //  if it fails  -->>  dislog for 'retry'
		document.getElementById('msgIDnotFound').setAttribute("hidden", "false");
		document.getElementById('retryMsgId').setAttribute("disabled", "false");  
		sizeToContent();
		window.focus();
    }				
}

function rmFx_retryMsgId() {

	if (rmFx_cmdID.indexOf('UID:') > -1) {
	   rmFxMsg.sendwUIDgo();
		window.close();
	} else {
		var msgHdr = reminderFox_MessageIdFinder(rmFx_cmdID);
		if (msgHdr) {
			window.close();
		}
	}	
}


function reminderFox_changeMessageLabel(addTag) {
		var msgHdr = gDBView.hdrForFirstSelectedMessage;
	
		// messageID
		var messageId =  msgHdr.messageId;				
		var openmsginnewwin= false;
		reminderFox_OpenMessageByMessageID(messageId,openmsginnewwin,addTag, true)
}

function rmFxMsgHdrDate (dateStr) { 
	// PRTime is in microseconds, Javascript time is in milliseconds
	// so divide by 1000 when converting
	
	var time = new Date();
	time.setTime(dateStr / 1000);
   
	var timeString = reminderFox_mail_getTimeString( time );
	var dateVariableString;
	try {
      dateVariableString = reminderFox_getUnicodePref(REMINDER_FOX_PREF + "." + REMINDER_FOX_LIST_DATE_LABEL);
    	} catch(e) {
	}   
	var remFoxDate =reminderFox_getDateVariable( null, time, dateVariableString ) + "  " + timeString;
	return remFoxDate;
}


// part 1   -------------------------
 //  Add email reminder for current selected message

function reminderFox_thunderBirdAddEmailReminder() {

	try {
		document.getElementById('threadPaneContext').hidePopup();
	} catch (e) {}
	try {
	document.getElementById('messagePaneContext').hidePopup();
	} catch (e) {}

	var msgSelected = GetSelectedMessages();
	
	// ("works for all selected messages");	
	if (msgSelected.length > 1) {
		window.GetThreadTree().view.selection.clearSelection();	
	}
	
	for (var nHdr = 0; nHdr < msgSelected.length; nHdr++) {
	
		var i = msgSelected[nHdr].indexOf("#");
		var nextHeader = msgSelected[nHdr].substring(i +1);
		
		var msgDBView = {};
		msgDBView = window.gDBView;
		msgDBView.selectMsgByKey(nextHeader);
		
		var msgHdr = gDBView.hdrForFirstSelectedMessage;
	 
	    // subject
		var remFoxSummary = msgHdr.mime2DecodedSubject;
		// from
		var remFoxFrom =  msgHdr.mime2DecodedAuthor;        
		// recipients
		var remFoxTo = msgHdr.mime2DecodedRecipients;        
	
		var remFoxPrio =msgHdr.priority;
	    
		//  add text from hightlighted mail-text
		var remFoxDetails = null;
		var focusedWindow = document.commandDispatcher.focusedWindow;
		var selectedText = focusedWindow.getSelection();
		
		if (selectedText != null && selectedText != "") {
			 remFoxDetails = "\n\n" +	reminderFox_getBundle().getString("rf.add.mail.message.details") + 
		 	 	":\n" + 	selectedText.toString();        
		}

		// messageID
		var messageId =  msgHdr.messageId;
		// strip out quotes as the extractHeader method returns some message-id's with extraneous quotes
		// like: "000c01c6941b$6ddb3c30$7be040"@foo.com
		messageId = messageId.replace(new RegExp(/\"/g),"");
		var remFoxMessageID = "<" + messageId + ">";
	   
		// date 
		var remFoxDate = rmFxMsgHdrDate (msgHdr.date);
	    
		var newDate = new Date();
		newDate.setDate( newDate.getDate() + 1 );  // default to using tomorrow's date for reminder
	
		var reminderId =reminderFox_generateUniqueReminderId( newDate );
		var mailIdentifierString = reminderFox_getBundle().getString("rf.add.mail.message.mail.identifier");
		var	newReminderToBeAdded = new ReminderFoxEvent( reminderId, newDate, mailIdentifierString + " " + remFoxSummary );
		newReminderToBeAdded.messageID = remFoxMessageID;
	
		// add default message header info to the Notes section
		newReminderToBeAdded.notes = 
			reminderFox_getBundle().getString("rf.add.mail.message.sender")		+ ": " + remFoxFrom   +  "\n" + 
			reminderFox_getBundle().getString("rf.add.mail.message.recipients")	+ ": " + remFoxTo     +  "\n" + 
			reminderFox_getBundle().getString("rf.add.mail.message.date")			+ ": " + remFoxDate   +  "\n" + 
			reminderFox_getBundle().getString("rf.add.mail.message.subject")		+ ": " + remFoxSummary; 
		
		if ( remFoxDetails != null ) { 
			newReminderToBeAdded.notes = newReminderToBeAdded.notes + remFoxDetails;
		}
	
	// PRIORITY definition for  RmFx and  TB
	// const REMINDER_PRIORITY_NORMAL = null;  // default
	// const REMINDER_PRIORITY_IMPORTANT = 1;
	//	TB header.priority:  6= very high;  5=high;  1=normal;  3=low;  2=very low
	
		if ( msgHdr.priority >= 5 ) { 			// for TB 'very high' and 'high'
			newReminderToBeAdded.priority = 1;	// set RmFx 'Important'
		}
			
		var added = reminderFox_addReminderHeadlessly( newReminderToBeAdded );		
		if (added) {
			rmFx_msgTAGing("Reminderfox", true, "#993399");
		} else {
			// only if more remaining reminders!!
			if ((msgSelected.length - nHdr - 1) > 0) {
				// if the last msg was deleted, ask to terminate all remaining or continue
				var title =	reminderFox_getBundle().getString("rf.add.addreminder.title");
				var msg =	reminderFox_getBundle().getString("rf.add.addreminder.instruction2")
							+	"\n\n" + reminderFox_getBundle().getString("rf.add.addreminder.instruction3") + " » "
							+ (msgSelected.length - nHdr - 1) 
	 						+ " « " +  reminderFox_getBundle().getString("rf.add.addreminder.instruction4");
				var key0 =	reminderFox_getBundle().getString("rf.button.ok");
				var key1 =	"No, terminate."; // reminderFox_getBundle().getString("rf.add.addreminder.cancel"); 
			    	
				if (rmFxCore.ConfirmEx(title, msg, key0, key1) == 1 ) {  // cancel pressed
					 nHdr = msgSelected.length +1; 
				}
			}
		}			
	}
}
/* 
 * part 2  ---------------------
 *
 *    retrieve and display this reminder's associated email in Thunderbird
 */


//gW displayMail 
function reminderFox_displayMailbyMsgID(recentReminder) {
	    reminderFox_openByMessageID(recentReminder);
}


function reminderFox_doShowMail() {
	var currentReminder = getReminderForSelectedItem( );
	if ( currentReminder.messageID != null ) {
		reminderFox_openByMessageID(currentReminder);
	}
}

function reminderFox_doShowMailTodo() {
	var currentTodo = getTodoForSelectedItem( );
	if ( currentTodo.messageID != null ) {	
		reminderFox_openByMessageID(currentTodo);	
	}
}

function reminderFox_doShowMailShortcut() { 
	if ( isReminderTabSelected() ) {
		reminderFox_doShowMail();
	}
	else {
		reminderFox_doShowMailTodo();
	}
}

function reminderFox_openByMessageID(currentReminder){
	var finalMessageId = reminderFox_finalMessageId(currentReminder.messageID);

	rmFx_currentSummary = currentReminder.summary;

	// if using Firefox, this starts Thunderbird ... 
	// using a specific 'commandLine' Handler 
    if( !reminderFox_isThunderBird() ) {   	
	//gW   alert( reminderFox_getBundle().getString("rf.add.mail.thunderbird.message") );

		var mailAppPath = rmFx_mailSystemPath();
		if ((mailAppPath == null) || (mailAppPath == ""))  {
			rmFxCore.PromptAlert(reminderFox_getBundle().getString("rf.schedule.abNotFound"));
            return;
        }
	
		var args = new Array();   
		args [0] = "-reminderFox";
		args [1] = "msgID:" + finalMessageId;    
		args [2] = "-msgString"; 
		args [3] = escape(rmFx_currentSummary); 				// currentReminder.summary;
		
		go4Process.init(mailAppPath);
		go4Process.run(false, args, args.length);
	
    	return;		// FX schedules TB with msgID:messageID -msgString rmFx_currentSummary
    }   

	if (finalMessageId !="" ) {
		var msgHdr = reminderFox_MessageIdFinder(finalMessageId);

		if (!msgHdr) {
			var strMsgIdNotFound = reminderFox_getBundle().getString("rf.add.mail.messageIdNotFound.message") +
					"\n" + rmFx_currentSummary  + 
					"\n(Message-ID: " + finalMessageId +")";
			rmFxCore.PromptAlert(strMsgIdNotFound);
		}
	}
}

function reminderFox_finalMessageId(messageId){
 	var midleft = (messageId.toLowerCase()).search("<"); 
 	var finalMessageId;
 	if (midleft == -1)
      	finalMessageId = "";
	else {
 	   var midRight = (messageId.substring(midleft)).search(">");
       finalMessageId =  messageId.substring(midleft + 1, midRight );
	}
	return finalMessageId;
}

function reminderFox_clearLabelByMessageID(messageId){
	// this function only works in ThunderBird -
	// if using Firefox, this starts Thunderbird ... and {for the moment}
	// requires to manually reselect the "view Mail" in TB/reminderFox environment
    if( !reminderFox_isThunderBird() ) {   	
	// gW alert( reminderFox_getBundle().getString("rf.add.mail.thunderbird.message") );
			{   
			var  shell = Components.classes["@mozilla.org/browser/shell-service;1"]
				.getService(Components.interfaces.nsIShellService);
	
			if (shell)
				shell.openApplication(Components.interfaces.nsIShellService.APPLICATION_MAIL);
			}
    	return;
    }   

 	var midleft = (messageId.toLowerCase()).search("<"); 
 	var finalMessageId;
 	if (midleft == -1)
      	finalMessageId = "";
	else {
 	   var midRight = (messageId.substring(midleft)).search(">");
       finalMessageId =  messageId.substring(midleft + 1, midRight );
      }

	if (finalMessageId !="" )  reminderFox_OpenMessageByMessageID( finalMessageId, false, 0, false);
}




//  part 3   -------------------------
/*
 * based on: MessageID-Finder for Mozilla by
 * 
 * Markus Hossner - markushossner@gmx.de
 * 
 */

const reminderFox_pmpB = 0;		//Boolean
const reminderFox_pmpN = 1;		//Integer
const reminderFox_pmpS = 2;		//Char

var reminderFox_prefRead = false;
var reminderFox_accountURIs = new Array();
var reminderFox_msgWindow;


function reminderFox_MessageIdFinder(strmessageid) {
    
    strmessageid = reminderFox_ExtractMessageID(strmessageid);

	var msgHdr = reminderFox_OpenMessageByMessageID(strmessageid,true);
	return msgHdr;        
}


function reminderFox_getMsgWindow() {
	if ( reminderFox_msgWindow == null ) {
		reminderFox_msgWindow = Components.classes["@mozilla.org/messenger/msgwindow;1"].
				createInstance(Components.interfaces.nsIMsgWindow);
	}
	return reminderFox_msgWindow;
}


function reminderFox_ExtractMessageID(strmessageid) {
    var midParts = strmessageid.replace(/^<|>$/g, "")
                               .split(":");

    switch (midParts.length) {
        case 1:
            strmessageid = strmessageid;
            break;

        case 2:
            if (midParts[0] == "news" || midParts[0] == "nntp") {
                strmessageid = midParts[1].replace(/^\/\/.*?\// ,"");
            } else if (midParts[0] == "mailto") {
                strmessageid = midParts[1];
            }
            break;

        case 3:
            strmessageid = midParts[2].replace(/^.+?\// ,"");
            break;

        default:
            strmessageid = "";
            break;
    }
    return strmessageid;
}


/*
 * Opens and selects a message by messageid
 *
 *  //gW 2006-10-11  .... added
 *
 *   Finds a message by messageid .... and by option
 *   'openmsginnewwin'
 *     = true    opens msg 
 *     = false   only selects Folder and Pane ... to be able to 'label' the message
 *
 *   Message is labeled/tagged with optional parameter
 *   'labelTag'  'opTag' 
 *      TB1.5
 *      	labelTag = 0 noLabel   =1 ... =5  see Label Options with Pull-Down Menue
 *			opTag   not used
 *      TB2.0
 *      	labelTag = 1: Important(red)  2:Work(yell)  3:Personal(green)  4:To Do(blue)  5:Later(viol)
 *			opTag = true: add Tag    opTag = false: remove Tag
 */

function reminderFox_OpenMessageByMessageID(messageId,openmsginnewwin,labelTag,opTag) {
	reminderFox_AddNewsServers();   
    window.setCursor("wait");

    var msgHdr = reminderFox_SearchMessageLocally(messageId);
     if (msgHdr) {
        var folderUri = msgHdr.folder.URI;
        
        if (openmsginnewwin) {
            var folder = reminderFox_GetMsgFolderFromUri(folderUri);
            var messageUri = folder.getUriForMsg(msgHdr);
                     
            window.openDialog("chrome://messenger/content/messageWindow.xul", "_blank",
                              "all,chrome,dialog=no,status,toolbar", messageUri, folderUri, null);
        }
       	// select message in the mail index
       	try { 
            var tree = {};
            var msgDB = {};
            var length = {};
            var wintype = {};
            var msgDBView = {};
            var indicesArray = {};
             reminderFox_msgWindow = reminderFox_getMsgWindow();
            if (document.firstChild.id == "messengerWindow") {
                 wintype = window.document.firstChild.getAttribute("windowtype");
                reminderFox_msgWindow.SetDOMWindow(window);
                
                folder = reminderFox_GetMsgFolderFromUri(folderUri);
                msgDB = folder.getMsgDatabase(reminderFox_msgWindow);
                msgDB.MarkHdrRead(msgHdr, false, null);
                reminderFox_msgWindow.SelectFolder(folderUri);

                msgDBView = window.gDBView;
                if (wintype != "mail:messageWindow") tree = window.GetThreadTree();
            } else {
                wintype = window.opener.document.firstChild.getAttribute("windowtype");
                reminderFox_msgWindow.SetDOMWindow(window.opener);

                folder = reminderFox_GetMsgFolderFromUri(folderUri);
                msgDB = folder.getMsgDatabase(reminderFox_msgWindow);
                msgDB.MarkHdrRead(msgHdr, false, null);
                reminderFox_msgWindow.SelectFolder(folderUri);

                msgDBView = window.opener.gDBView;
                if (wintype != "mail:messageWindow") tree = window.opener.GetThreadTree();
            }
                        
            if (wintype != "mail:messageWindow") tree.view.selection.clearSelection();
            msgDBView.selectMsgByKey(msgHdr.messageKey);
            msgDBView.loadMessageByMsgKey(msgHdr.messageKey);
            msgDB.MarkHdrRead(msgHdr, true, null);
            msgDBView.getIndicesForSelection(indicesArray,length);
            if (wintype != "mail:messageWindow") tree.treeBoxObject
                                                     .ensureRowIsVisible(indicesArray.value[0]);
       	}
       	catch( e ) {       

       	}
      }
	// extract the tag keys from the msgHdr	
	if (msgHdr != null && labelTag != null ) { 	
		rmFx_msgTAGing("Reminderfox", opTag, "#993399" );
		
		// delete all iCal-xxxx tags eg: PUBLISH, REQUEST, REPLY, CANCEL		
   	var msgKeyArray = msgHdr.getStringProperty("keywords").split(" ");
		if ((opTag == false) && (msgKeyArray.length > 0))  {
			for (var n= 0; n< msgKeyArray.length; n++  ) {
				if (msgKeyArray[n].indexOf("iCal") == 0) {
					rmFx_msgTAGing(msgKeyArray[n], false);
				}
			}
		}
	}
    window.setCursor("auto");
    return msgHdr;
}


// * Searchs for messageid in local folders
function reminderFox_SearchMessageLocally(messageId) {
    var msgHdr = null;
    var folder = null;
    for(var x = 0; x < reminderFox_accountURIs.length && !msgHdr; x++) {  
        folder = reminderFox_GetMsgFolderFromUri(reminderFox_accountURIs[x]).rootFolder;
        msgHdr = reminderFox_SearchInSubFolder(folder, messageId);  
    }
    return msgHdr;
}

//  * Searchs in subfolder
function reminderFox_SearchInSubFolder(folder, messageId) {

	var tb_prefs = Components.classes["@mozilla.org/preferences-service;1"].
            getService(Components.interfaces.nsIPrefBranch);	
	var tbVersion = tb_prefs.getCharPref("general.useragent.extra.thunderbird");

	if (tbVersion.search("Thunderbird/3.") == -1) { // not in TB3.			

			if (folder.hasSubFolders) {
				var subfolders = folder.GetSubFolders();
				var subfolder = null;
				var msgHdr = null;
				var msgDB = null;
				var currentFolderURI = "";

				var done = false;
  
				while(!done) {
					currentFolderURI = subfolders.currentItem()
                                   .QueryInterface(Components.interfaces.nsIRDFResource).Value;
					subfolder = reminderFox_GetMsgFolderFromUri(currentFolderURI);

					if (currentFolderURI.substring(1,7) != "news://") {  
						msgHdr = reminderFox_SearchInSubFolder(subfolder, messageId);
					}
					if (!msgHdr) {
   
						try {
							reminderFox_msgWindow = reminderFox_getMsgWindow();
							msgDB = subfolder.getMsgDatabase(reminderFox_msgWindow);
						} catch (ex) {

					      	// subfolder.updateFolder(reminderFox_msgWindow); // TM: this call was causing a hang in some instances
								// try {
								// // msgDB = subfolder.getMsgDatabase(reminderFox_msgWindow);
								// } catch (ex) {
								// }
						}

						if ( msgDB != null ) {
							msgHdr = msgDB.getMsgHdrForMessageID(messageId);
						}
					}
					if (msgHdr) return msgHdr;
         
					try {
					    subfolders.next();
					} catch(e) {
					    done = true;
					}
				}
			}  // TB2.   if (folder.hasSubFolders)
			return null;			
			
	} else {	// in TB3. 
				// http://mxr.mozilla.org/comm-central/source/mailnews/base/resources/content/folderWidgets.xml#496
						// var msgFolder = folder.QueryInterface(Components.interfaces.nsIMsgFolder);
		
			var subfolder = null;
			var msgHdr = null;
			var msgDB = null;
			var currentFolderURI = "";

			var done = false;
													
			if (folder.hasSubFolders) {
	
				var subfolders = folder.subFolders;
				while (subfolders.hasMoreElements()) {
					var subfolder = subfolders.getNext().QueryInterface(Components.interfaces.nsIMsgFolder);
	
					// ??????
					if (currentFolderURI.substring(1,7) != "news://") {  
						msgHdr = reminderFox_SearchInSubFolder(subfolder, messageId);
					} // ????
					
					if (!msgHdr) {
						try {
							reminderFox_msgWindow = reminderFox_getMsgWindow();
							msgDB = subfolder.getMsgDatabase(reminderFox_msgWindow);
						} catch (ex) {}

						if ( msgDB != null ) {
							msgHdr = msgDB.getMsgHdrForMessageID(messageId);
						}
					}
					if (msgHdr) return msgHdr;
         
					try {
					    subfolders.next();
					} catch(e) {
					    done = true;
					}
				}
			} 
		return null;
	}
}


// * Searchs all availible newsserver
function reminderFox_AddNewsServers() {
    if (reminderFox_prefRead == false) {
        var accounts = reminderFox_pmpReadPref("mail.accountmanager.accounts",reminderFox_pmpS);
        if (accounts) {
            var accountsArray = accounts.split(",");
            
            for (var x = 0; x < accountsArray.length; x++) {
                reminderFox_AddNewsServerMenuItem(accountsArray[x]);
            }
            reminderFox_accountURIs.sort(reminderFox_sortAccountUris);
        }

        reminderFox_prefRead = true;
    }
}


// * Sortfunction for reminderFox_accountURIs Array Local Folder to the rear
function reminderFox_sortAccountUris(a, b) {

    if (a.search(/Local%20Folders/) != -1) {
        return 1;
    } else if (b.search(/Local%20Folders/) != -1) {
        return -1;
    } else if (a < b) {
        return -1;
    } else if (a > b) {
        return 1;
    } else {
        return 0;
    }
}


// * Adds newsserver to the context menu
function reminderFox_AddNewsServerMenuItem(account) {
    var server    = reminderFox_pmpReadPref("mail.account." + account + ".server",reminderFox_pmpS);
    var servertyp = reminderFox_pmpReadPref("mail.server."  + server +  ".type",reminderFox_pmpS);
    var hostname  = reminderFox_pmpReadPref("mail.server."  + server +  ".hostname",reminderFox_pmpS);
    var username  = reminderFox_pmpReadPref("mail.server."  + server +  ".userName",reminderFox_pmpS);

    var accountURI = "";
    
    if (servertyp == "nntp") {
        var servername = reminderFox_pmpReadPref("mail.server." + server + ".name",reminderFox_pmpS);
        var serverport = reminderFox_pmpReadPref("mail.server." + server + ".port", reminderFox_pmpN);
        // var newsservermenuitem;

        if (servername == null) servername = hostname;
        if (serverport == null) serverport = 119;

// newsservermenuitem = document.createElement("menuitem");
// newsservermenuitem.setAttribute("label", servername);
// newsservermenuitem.setAttribute("value",server);
// newsservermenuitem.setAttribute("oncommand","reminderFox_MessageIdFinder('" +
// hostname + "', '" + String(serverport) + "','');");

        accountURI = "news://" + escape(hostname);
    } else if (servertyp == "imap") {
        accountURI = "imap://" + escape(username) + "@" + escape(hostname);
    } else {
        accountURI = "mailbox://" + escape(username) + "@" + escape(hostname);
    }

    if (hostname != null) reminderFox_accountURIs.push(accountURI);
}



// * Reads the value of pmpName out of the mozilla preferences
function reminderFox_pmpReadPref(pmpName, pmpType) {
    var nsIPrefBranch = Components.interfaces.nsIPrefBranch;
    var pref = Components.classes["@mozilla.org/preferences-service;1"]
                         .getService(nsIPrefBranch);
    var pmpValue = null;
    
    if (pref.prefHasUserValue(pmpName)) {
        switch (pmpType) {
            case reminderFox_pmpB:
                pmpValue = pref.getBoolPref(pmpName);
                break;
            case reminderFox_pmpN:
                pmpValue = pref.getIntPref(pmpName);            
                break;
            case reminderFox_pmpS:
                pmpValue = pref.getCharPref(pmpName);
                break;
            default:
                break;
        }
    }
    
    return pmpValue;
}

// * Get msgfolder from Uri
function reminderFox_GetMsgFolderFromUri(uri) {
    var msgfolder = null;
    
    try {
        var RDF = Components.classes["@mozilla.org/rdf/rdf-service;1"]
                            .getService(Components.interfaces.nsIRDFService);
        var resource = RDF.GetResource(uri);
        
        if (resource instanceof Components.interfaces.nsIMsgFolder &&
           (resource.parent || resource.isServer))
           msgfolder = resource;
           
    } catch (ex) {}

    return msgfolder;
}



/* write the messageId to the associated reminder
 * 
 *	@param		srcUri 	- folder address
 * 				offset	- pointer to the begin of the msg
 */ 
function rmFx_checkMsgAndUpdateReminder (srcUri, offset) {

	var msgUri = reminderFox_GetMsgFolderFromUri(srcUri).baseMessageURI + "#" + offset;

	var messenger = Components.classes["@mozilla.org/messenger;1"].createInstance()
				.QueryInterface(Components.interfaces.nsIMessenger);
	var referencedReminders = rmFxGetRmRef(messenger.messageServiceFromURI(msgUri).messageURIToMsgHdr(msgUri));
	// the 'referencedReminders' comes back with 'messageID' set !!

	var msg = "";	
	if (referencedReminders.length > 0) {			
		msg = ("Referenced Reminders: " + referencedReminders.length + "\r\n"
			 + referencedReminders[0].summary + "\r\n"
			 + "msgId: " + referencedReminders[0].messageID 
			 + "  msgRef: " + referencedReminders[0].id + "\r\n" 
			 + msgUri + "\r\n");
			 
	// now update the ".id" Reminder with the ".messageID"
		var activeReminders = reminderFox_getReminderEvents();	

		for ( var i = 0; i < activeReminders.length; i++ ) {
			if (activeReminders[i].id == referencedReminders[0].id ) {
	
			reminderFox_logMessageLevel ("found: " + activeReminders[i].summary
					+ "\r\n pos: " + i,  REMINDER_FOX_LOG_LEVEL_FINE);

			reminderFox_removeElement(activeReminders, i);
			reminderFox_insertIntoArray(activeReminders, referencedReminders[0], i);
			reminderFox_writeOutRemindersAndTodos(false);   // isExport
			}
		}
	}
	return msg;
}
////////////////// end of 'MessageID' //////////////////////////////////////////



/**  --- rmFx_folderListener  ----------------------------------------------- */

/* folder listener used with	SEND++  */  
	var rmFx_FolderListener = {
		OnItemEvent: function(folder, event) {
		//logMsg ("rmFx_Folder Listener " + event.toString());
		},
		OnItemAdded: function(parentItem, item) {
		// logMsg ("Folder Listener OnItemAdded:" + parentItem.Value + "  " + item.messageKey);
		},
		OnItemIntPropertyChanged: function(item, property, oldValue, newValue) {

			//Send Alarm		with: GenericSendMessage(nsIMsgCompDeliverMode.Later);
			if ((item.Value == "mailbox://nobody@Local%20Folders/Unsent%20Messages") 
					&& (property.toString() == "TotalMessages")) {
				reminderFox_logMessageLevel  ("UNSENT Folder " + property.toString() + ": " + oldValue + " " + newValue, 
					REMINDER_FOX_LOG_LEVEL_FINE);
			}
			
			// SEND++     with: GenericSendMessage(nsIMsgCompDeliverMode.Now);
			if ((item.Value == rmFx_FCC) 
					&& (property.toString() == "FolderSize")) {
				var msg = "SEND Folder " + property.toString() + ": " + oldValue + " " + newValue;
				if ( oldValue != newValue) {
					// reset the 'send folder' and Listener to process only once
					rmFx_FCC = "";   
					rmFx_setFolderListener("remove");

					var msg = rmFx_checkMsgAndUpdateReminder (item.Value, oldValue);
					if (msg == "") {
						msg = "SEND Folder " + property.toString() + ": " + oldValue + " " + newValue;						
					}
					reminderFox_logMessageLevel (msg, REMINDER_FOX_LOG_LEVEL_FINE);
				}
			}
		}
	}
	

function rmFx_setFolderListener(mode) {
	const mailSessionContractID = "@mozilla.org/messenger/services/session;1";
	const nsIMsgMailSession = Components.interfaces.nsIMsgMailSession;
	var mailSession = Components.classes[mailSessionContractID].getService(nsIMsgMailSession);
	var nsIFolderListener = Components.interfaces.nsIFolderListener;

//gW_report
//    Components.utils.reportError("rmFx_setFolderListener   mode: " +  mode);

	if (mode == "add") {
		mailSession.AddFolderListener(rmFx_FolderListener, nsIFolderListener.intPropertyChanged);
	}
	if (mode == "remove") {
		mailSession.RemoveFolderListener(rmFx_FolderListener);
	}
}


//**  --- rmFx_copyListener -----------------------------------------------------

var rmFx_copyServiceListener =  { 
		sfileNP: null, 
		QueryInterface: function(iid) {
			if (iid.equals(Components.interfaces.nsIMsgCopyServiceListener) ||
							iid.equals(Components.interfaces.nsISupports)) {
					return this;
			}
			throw Components.results.NS_NOINTERFACE;
			return 0;
		},
		OnProgress: function (progress, progressMax) {
		},
		OnStartCopy: function () {
			// alert ("START  Copy from SEND ALARM")
		},
		OnStopCopy: function ( status ) {
			// alert ("STOP   Copy from SEND ALARM")
		},
		SetMessageKey: function (key ) {
			// alert ("SetMessageKey: " + key )
		}			
}

//////////////  rmFx_sendAlarmMail() ///////////////////////////////////////////
 	/**  EXAMPLE   TEST  EXAMPLE   TEST  EXAMPLE   TEST  EXAMPLE   TEST  EXAMPLE
 	 * called from a test entry in addreminder-dialog.xul
 	 *  
 	 * This function sends a message from the "default" TB mail account.
 	 * The passed parameters are used to build a message
 	 * which is temporarily written as a file and using
 	 * '.sendMessageFile' to send the message without using a 'compose' dialog.
 	 * 
 	 * IMPORTANT:
 	 * 	If this 'alarm' has to be send using the '-reminderFox' commad handler
 	 * 	as an error / security check the file requires to contain
 	 * 	'UID:reminder.id' the refID of the reminderfox event in question
 	 */
 	 
function rmFx_sendAlarmMail() {	
	rmFxUtil.setStatus ("Sending [Alarm] message!"); 		//gW RmFxStatusbar

	var currentReminder = getReminderForSelectedItem(); 
	
	var subject = "[ALARM] " + (currentReminder.summary);
	
	var toAddresses = "testFox <testFox@xyz.ab>";
	var fromAddress = "testFox <testFox@xyz.ab>";

	var body =	"\n\nThis is a ReminderFox 'Alarm' test."
				+	  "\nSimulating an MAIL triggered from rising an alarm event.\n\n" ;
	

	// add to 'body' some specific items for this 'event'				// $$$extString$$$

	if (!!currentReminder.categories){
			body += "*Categories* " + currentReminder.categories  + "\n";
	}
	if (!!currentReminder.location){
			body += "*Location* " + currentReminder.location  + "\n";
	}
	if (!!currentReminder.url){
			body += "*URL* " + currentReminder.url  + "\n";
	}
	if (!!currentReminder.notes) {
			body += "*Notes* ___________________________________\n"
			+ ">" + currentReminder.notes.replace(new RegExp(/\n/g),"\n>");
	}

	var refID = currentReminder.id;
	var footer = "UID:" + refID;


	// create tmpFile
	var tmpMsgFile = 	rmFxMsg.FileCreate(
										subject, 
										fromAddress, 
										toAddresses,
										1, 	/* priority higest */
										body, 
										footer,
										refID);
	
	rmFxMsg.FileSend (	
					subject,
					fromAddress,
					toAddresses,
					1,  	/* priority */	
					tmpMsgFile, refID);
							
	rmFxUtil.setStatus ("[ALARM] has been send!", ""); 		//gW RmFxStatusbar
}

 
//////////////////// utilities for Messages/Alarms /////////////////////////////

function rmFxMsg () {
} 

	rmFxMsg.Compose = function (subject, fromAddress,  toAddresses,
				priority, body, footer, refID, iCalToEmailFile, methodTyp)
	/** ===================================================================== **/	
	{if (rmFxMsg.messenger()) 
		{	var fromId = rmFxMsg.getIdentity (fromAddress);
	
	
			if (iCalToEmailFile != null) {	
				var msgAttachment 				= Components.classes["@mozilla.org/messengercompose/attachment;1"]
															.createInstance(Components.interfaces.nsIMsgAttachment);
				msgAttachment.temporary 		= true;
				msgAttachment.name 				= iCalToEmailFile.leafName;
				msgAttachment.contentType 		= "text/calendar;"		
				msgAttachment.contentTypeParam= "method=" + methodTyp + "; charset=UTF-8";
				msgAttachment.url 				= "file://" + iCalToEmailFile.persistentDescriptor;  
			}
		  
			// mail header
	   	var composeFields = Components.classes["@mozilla.org/messengercompose/composefields;1"]
	                                 .createInstance(Components.interfaces.nsIMsgCompFields);
			composeFields.useMultipartAlternative = true;
	   
			composeFields.characterSet = "UTF-8";
			composeFields.from 			= fromId.email;
			composeFields.replyTo		= fromId.email;
			
			toAddresses = (toAddresses == "null") ? "" : toAddresses;
			composeFields.to 				= toAddresses;				// ???????????

				function exHtml(xString){
					return xString.replace(new RegExp(/</g),"&lt;").replace(new RegExp(/>/g),"&gt;")
				}
			composeFields.subject 		= subject;			
			composeFields.body 			= exHtml(body + footer);
			composeFields.priority		= priority;

			if (iCalToEmailFile != null) {
				composeFields.addAttachment(msgAttachment);
			}
			// message compose paramaters
			var msgComposeParams					= Components.classes["@mozilla.org/messengercompose/composeparams;1"]
															.createInstance(Components.interfaces.nsIMsgComposeParams);
			msgComposeParams.composeFields 	= composeFields;
			msgComposeParams.identity 			= fromId;
			msgComposeParams.format 			= Components.interfaces.nsIMsgCompFormat.Default;
			msgComposeParams.type 				= Components.interfaces.nsIMsgCompType.New;
			
			// open a composer window
			var messengerCompose = Components.classes["@mozilla.org/messengercompose;1"]
						.getService().QueryInterface(Components.interfaces.nsIMsgComposeService);
						
			messengerCompose.OpenComposeWindowWithParams(null, msgComposeParams);

			rmFxUtil.setStatus ("Send message by " + fromId.identityName + " pending." , ""); 		//gW RmFxStatusbar 
		
	} else {
		/** -- NO 'messenger' .. (like FX) ----------------------------------- **/
		/*     calling TB -reminderFox COMPOSE:{info about what to compose}     */

		//messageString definition
		var msgString = "Subject:"  + subject 
					+ ";\n;From:"      + fromAddress 
					+ ";\n;To:"        + toAddresses 
					+ ";\n;Body:"      + body 
					+ ";\n;Footer:"    + footer 
					+ ";\n;priority:"  + priority
					+ ";\n;refID:"     + refID;
					
					
		if (iCalToEmailFile != null) {						
				msgString += ";\n;mailFile:"  + iCalToEmailFile.persistentDescriptor;
		}
		
		msgString = escape(msgString);

		var mailAppPath = rmFx_mailSystemPath();
			
		var args = new Array();   
		args [0] = "-reminderFox";
		args [1] = "COMPOSE:" + subject;
		args [2] = "-msgString"; 
		args [3] = msgString; 		// compose items to be passed
		
		go4Process.init(mailAppPath);
		go4Process.run(false, args, args.length);
	
    	return;		// FX schedules TB with COMPOSE:subject -msgString msgString
	 	}
	}


	var deleteSendFileOnCompletion = true;	// this is the tmpFile, not the 'Send' folder copy

	rmFxMsg.FileSend = function ( subject, fromAddress, toAddresses, 
												priority, mailFile, refID) 
	/** ===================================================================== **/	
	/** See also:
	 *		http://mxr.mozilla.org/comm-central/source/mailnews/compose/public/nsIMsgSend.idl
	 * 	http://mxr.mozilla.org/comm-central/source/mailnews/compose/public/nsIMsgCompFields.idl
	 * 
	 * 	param:	
	 * 		subject			the 'subject' the mail comes with					
	 * 		fromAddress		the 'FROM' address sending the msg
	 * 		toAddresses		the 'TO' addresses to receive the msg (csv)
	 * 		body			any message 'body' to be send 		
	 * 		tmpFile			file object containing the message  
	 */
	{if ( rmFxMsg.messenger()) {		//try	// 'in 'messenger' ??
	
		// need different code for TB2 and TB3 !!!
			try { // if fails we are in TB3, just use 'mailFile'
				var mailFileURL = rmFxUtil.getIOService().newFileURI(mailFile).spec;
				mailFile = Components.classes["@mozilla.org/filespec;1"]
			                       .createInstance(Components.interfaces.nsIFileSpec);
				mailFile.URLString = mailFileURL;
			} catch (ex) {}
		
			var fromId = rmFxMsg.getIdentity (fromAddress);
		
			var composeFields = Components.classes["@mozilla.org/messengercompose/composefields;1"]
		                                 .createInstance(Components.interfaces.nsIMsgCompFields);
			composeFields.characterSet = "UTF-8";
			composeFields.to 			= toAddresses;
			composeFields.from 			= fromId.identityName;
			composeFields.replyTo		= fromId.identityName;
			
			composeFields.priority		= rmFxMsg.setPriorityString (priority);
	
			
			var messengerSend = Components.classes["@mozilla.org/messengercompose/send;1"]
		                           .createInstance(Components.interfaces.nsIMsgSend);
			messengerSend.sendMessageFile(
		   			fromId,  			/* nsIMsgIdentity */
		            fromId.key,			/* nsIMsgCompFields */
		            composeFields,		/* nsIMsgCompFields */
		            mailFile,			/* nsFileSpec */
		            deleteSendFileOnCompletion,
		            false, 				/* digest_p */
		            	 					/* nsMsgDeliverMode */
						rmFxUtil.getIOService().offline 
							?	Components.interfaces.nsIMsgSend.nsMsgQueueForLater	/* = 1 */
							:	Components.interfaces.nsIMsgSend.nsMsgDeliverNow,		/* = 0 */	
		            null,  		/* nsIMsgDBHdr msgToReplace */
		            null,  		/* nsIMsgSendListener aListener */
		            null,  		/* nsIMsgStatusFeedback aStatusFeedback */
		            "");    		/* password */
	
		} else { // if the above fails .. in 'NON messenger'

			rmFxMsg.sendwUID (refID, mailFile.persistentDescriptor);
		}
	} 
		
	rmFxMsg.FileCreate = function (subject, fromAddress, toAddresses, priority, 
														body, footer, 
														refID, iCalString, methodTyp)
	/** ===================================================================== **/
	/*   FX:  encodes the whole 'content' string with .encodeUTF8              */
	/*   TB:  NO encodes the whole 'content'                                   */
	{	var thisdate = new Date();
	
		// add app info  .. will be added to the 'footer'
		var osInfo = rmFx_opSystemInfo();
		var appInfo = Components.classes["@mozilla.org/xre/app-info;1"] 
			.getService(Components.interfaces.nsIXULAppInfo);
		var appDetails = "\n  " + appInfo.name + " " + appInfo.version 
						     + " (" + appInfo.platformBuildID + ") -- " + osInfo;

		var content =     "MIME-version: 1.0\r\n";
		content +=        "To: " 	+ toAddresses + "\r\n";
		
		if ( rmFxMsg.messenger()) {
			var contentS = rmFxMsg.encodeMimeHeader("Subject: " + subject) + "\r\n";  
			contentS +=    "From: " 	+ rmFxMsg.getIdentity (fromAddress).identityName + "\r\n"; 
		} else {
			var contentS = "Subject: " + subject + "\r\n";
			contentS +=    "From: " 	+ fromAddress + "\r\n";  
		} 
		content += contentS;
		
		content += "Date: " + rmFxUtil.mailDateTime(thisdate, "mailDate") + "\r\n";	
		content += rmFxMsg.setPriorityString(priority) + "\r\n";
		content += "Content-class: urn:content-classes:reminderfox\r\n";
		
		if (refID != "") {
			content
			+= "Reference-ID: <" + refID + rmFx_ReferenceID + ">\r\n"
			 + "Message-Id: <" + refID + rmFx_ReferenceID + ">\r\n";
		}
		
		// if 'iCalString' and 'methodTyp'  send with iCal attachment		
		if (!!iCalString && !!methodTyp) {
			content	
			+= ("Content-type: multipart/mixed; boundary=\"anhang_1234567890_0987654321\"\r\n"
         +      "\r\n\r\n"
         +      "--anhang_1234567890_0987654321\r\n"
         +      "Content-type: multipart/alternative;\r\n"
         +      " boundary=\"anhang_0987654321_1234567890\"\r\n"
         +      "\r\n\r\n"
         +      "--anhang_0987654321_1234567890\r\n"
         +      "Content-type: text/plain; charset=UTF-8\r\n"
         +      "Content-transfer-encoding: 8BIT\r\n"
         +      "\r\n"
         
         +      body 

			+ "\n-- "  /* footer delimiter line !!! do not delete !  
	      					 this notation will cut the following part from plain-text-reply !*/
			+  "\n" + footer + appDetails  
	      +  "\n  ________________________________________________"
	      +  "\n  http://reminderfox.mozdev.org/\n"
         
         +      "\r\n\r\n\r\n"
         +      "--anhang_0987654321_1234567890\r\n"
         +      "Content-type: text/calendar; method=" + methodTyp + "; charset=UTF-8\r\n"
         +      "Content-transfer-encoding: 8BIT\r\n"
         +      "\r\n"
         
         +      iCalString
         +      "\r\n\r\n"
         
         +      "--anhang_0987654321_1234567890--\r\n\r\n"

         +      "--anhang_1234567890_0987654321\r\n"
         +      "Content-type: application/ics; name=invite.ics\r\n"
         +      "Content-transfer-encoding: 8BIT\r\n"
         +      "Content-disposition: attachment; filename=invite.ics\r\n"
         +		"\r\n"    /* need an extra line to separate header !! */
         
         +      iCalString	
         +      "\r\n\r\n"
         
         +      "--anhang_1234567890_0987654321--\r\n");
			
		} else {	// send message with inline text
		
			content 
			+= "Content-type: text/plain; charset=UTF-8\r\n" 
			+	"Content-transfer-encoding: 8bit\r\n\r\n" 
			+  body
			 
			+  "\n-- "  /* footer delimiter line !!! do not delete !  
	      					 this notation will cut the following part from plain-text-reply !*/
			+  "\n" + footer + appDetails
			+  "\n  ________________________________________________"
			+  "\n  http://reminderfox.mozdev.org/\n";
		}
		
		if ( !rmFxMsg.messenger()) {
			content = rmFxUtil.encodeUTF8(content);
		}
			
		// ------ write TMP file ---------------
		return  rmFxUtil.makeMsgFile8 (content, rmFxUtil.buildUIDFile(refID));
	}



	rmFxMsg.setPriorityString = function (priority) 
	/** ===================================================================== **/
	{	var vcPriority = "";
		switch (priority) {
		case "1":	cPriority		= "X-Priority: 1 (Highest)";	break;					
		case "2":	cPriority		= "X-Priority: 2 (High)"; break;
		case "3":	cPriority		= "X-Priority: 3 (Normal)"; break;
		case "4":	cPriority		= "X-Priority: 4 (Low)"; break;
		case "5":	cPriority		= "X-Priority: 5 (Lowest)"; break;
		default: cPriority		= "X-Priority: 3 (Normal)"; break;
		}
		return cPriority;
	}
	

/////////////////// 'SendFILE' for "NON" messenger   ///////////////////////////
		
	rmFxMsg.sendwUID = function (reminderID, msgString)
	/** ===================================================================== **/	
	// use a specific 'commandLine' Handler ... this is the NON 'messenger' part
	{	var mailAppPath = rmFx_mailSystemPath();
		var args = new Array();   
		args [0] = "-reminderFox";
		args [1] = "UID:"+ (reminderID);
		args [2] = "-msgString"; 
		args [3] = Components.classes["@mozilla.org/file/directory_service;1"]
					.getService(Components.interfaces.nsIProperties)
					.get("Progs", Components.interfaces.nsIFile).path.substring(3);
							// msgString;			// mailFile.persistentDescriptor

		var cDate = new Date();
		var msgLog = " ** Send with **   UID:" + reminderID + " at: " + cDate;
		rmFxUtil.setStatus(msgLog);
		
		go4Process.init(mailAppPath);
		go4Process.run(false, args, args.length);
	
    	return;		// scheduled TB with UID:reminderID -msgString mailFile.persistentDescriptor
    }   
    
    
	rmFxMsg.sendwUIDgo = function ()
	/** ===================================================================== **/	
	// called from 'commandLine' Handler ... this is the 'messenger' part
   
   {	if (!(rmFx_cmdID.indexOf('UID:') > -1)) { // check transfered code and validity
	   	return;	// not valid!! Terminate
	   }
	   window.close();

		var icsFile = rmFxUtil.buildUIDFile(rmFx_cmdID.substring(4))
	   var icsData = rmFxUtil.readInFileContents(icsFile)
	   						.replace(/(\r\n)/g,"\n");

		if (icsData.indexOf (rmFx_cmdID+"\n") == -1) {
			var msgError = "*** Transfered ICS data has error: -1 ***" 
					+ "\n   data >>" +  rmFx_cmdID + "<<"; 
			rmFxUtil.dump2Console (msgError);
			return;	// not valid!! Terminate
		}

		if (rmFx_cmdString !=  Components.classes["@mozilla.org/file/directory_service;1"]
					.getService(Components.interfaces.nsIProperties)
					.get("Progs", Components.interfaces.nsIFile).path.substring(3)) {
			var msgError = "*** Transfered ICS data has error: -2 ***";
 
			rmFxUtil.dump2Console (msgError);
			return;	// not valid!! Terminate
		}
					
	   var msgString = rmFx_cmdString.split(";\n;");
	
		// retrieve msg infos from 'ics file'  
	   var msgLines = icsData.split("\n");
	   						
	   var toAddresses	= msgLines[1].substring(4);
	   var subject 		= msgLines[2].substring(9);
	   var fromAddress	= msgLines[3].substring(6);
	   var priority 		= msgLines[5].substring(12,13);

		rmFxUtil.makeMsgFile (msgLines.join("\n"), icsFile);	 
	 
		var mailFile = Components.classes["@mozilla.org/file/local;1"]
					.createInstance(Components.interfaces.nsILocalFile);                              
		mailFile.initWithPath(icsFile);
	   
		rmFxMsg.FileSend(
					subject,
	   			fromAddress, 
	   			toAddresses, 
					priority, 
					mailFile);	
	}

//////////////////// 'COMPOSE' for NON 'messenger'   ///////////////////////////

	rmFxMsg.composeMSG = function (reminderID, msgString)
	/** ===================================================================== **/	
	// use a specific 'commandLine' Handler ... this is the NON 'messenger' part
	{	var mailAppPath = rmFx_mailSystemPath();
		var args = new Array();   
		args [0] = "-reminderFox";
		args [1] = "COMPOSE:"+ (reminderID);
		args [2] = "-msgString"; 
		args [3] = msgString;
		
		go4Process.init(mailAppPath);
		go4Process.run(false, args, args.length);
	
    	return;		// FX schedules TB with COMPOSE:reminderID -msgString msgString
    }   
    
  
	rmFxMsg.composeMSGgo = function ()
	/** ===================================================================== **/	
	// called from 'commandLine' Handler ... this is the 'messenger' part
   
   {	if (!(rmFx_cmdID.indexOf('COMPOSE:') > -1)) { // check transfered code and validity
	   				// for SECURITY reason check more !!! 			++2do ++2do ++2do
	   	return;	// not valid!! Terminate
	   }
	   window.close();

		// retrieve msg infos from passed window parameters
	   var msgString = unescape(rmFx_cmdString).split(";\n;");
		/* ----
		var msgString = "Subject:" + subject 
		 			+ ";\n;From:"     + fromAddress 
		 			+ ";\n;To:"       + toAddresses 
					+ ";\n;Body:"     + body 
					+ ";\n;Footer:"   + footer 
					+ ";\n;priority:" + priority
					+ ";\n;refID:"    + refID
					+ ";\n;mailFile:" + iCalToEmailFile.persistentDescriptor;
		------ */
		
	   var subject       = msgString[0].substring(8);
	   var fromAddress   = msgString[1].substring(5);
	   var toAddresses   = msgString[2].substring(3);
	   var body          = msgString[3].substring(5);
	   var footer        = msgString[4].substring(7);
	   var priority      = msgString[5].substring(9);
	   var refID         = msgString[6].substring(6);
	   
	   if (msgString[7] != null) {
		   var icsFile       = msgString[7].substring(9);
			var mailFile = Components.classes["@mozilla.org/file/local;1"]
						.createInstance(Components.interfaces.nsILocalFile);                              
			mailFile.initWithPath(icsFile);  
	   } else {
	   	mailFile = null;
	   }
	   
	//	var toAddresses   = "";
		var methodTyp     = "PUBLISH";

		/* ---
		alert ("\nsubject " 		+ subject
			+ "\nfromAddress " 	+ fromAddress
			+ "\nbody " 			+ body
			+ "\nrefID " 			+ refID
			+ "\nmailFile " 		+ icsFile); 
		--- */
		
		rmFxMsg.Compose (subject, fromAddress,  toAddresses,
				priority, body, footer, refID, mailFile, methodTyp);
	}


//////////////////// utilities 'messenger' /////////////////////////////////////

	rmFxMsg.messenger = function () 
	/** ===================================================================== **/
	{ return (Components.classes["@mozilla.org/messenger/account-manager;1"] != null);
	}

	rmFxMsg.getAccountMngr = function  ()
	/** ===================================================================== **/	
	{	return Components.classes["@mozilla.org/messenger/account-manager;1"]
				.getService().QueryInterface(Components.interfaces.nsIMsgAccountManager);
	}
	
	rmFxMsg.encodeMimeHeader = function (header)
	/** ====================================================================== **/	
	{	// http://www.xulplanet.com/references/xpcomref/ifaces/nsIMimeConverter.html
		var mimeConverter = Components.classes["@mozilla.org/messenger/mimeconverter;1"]
	                                  .createInstance(Components.interfaces.nsIMimeConverter);
		return mimeConverter.encodeMimePartIIStr(rmFxUtil.encodeUTF8(header), false, 
						"UTF-8", header.indexOf(":") + 2, 72);
	}

	rmFxMsg.myMailIDs = function ()
	/** ====================================================================== **/	
	/*			'messenger'       use mail.accountmanager.accounts and identities
	 *			NON 'messenger'   prefs = extensions.reminderFox.mail.sender
	 */
	{ if (rmFxMsg.messenger()) // OK: if we are in 'mail' system (TB, SM)

		{ 	// this is tree pass process to eliminate identities for 'nntp'
			//  sounds complicate ... but didn't found a straight forward process   
			var as = Components.classes["@mozilla.org/messenger/account-manager;1"]
		   	.getService(Components.interfaces.nsIMsgAccountManager).allServers;
			var servers="";
			for (var i = 0; i < as.Count(); ++i) {
				var nextTyp  = as.GetElementAt(i)
					.QueryInterface(Components.interfaces.nsIMsgIncomingServer).type;
				if (nextTyp != "nntp") {
					var nextKey  = as.GetElementAt(i)
						.QueryInterface(Components.interfaces.nsIMsgIncomingServer).key;
					servers += nextKey +",";
				}
			}

			var _prefs = Components.classes["@mozilla.org/preferences-service;1"].
		            getService(Components.interfaces.nsIPrefBranch);	
			var accounts = _prefs.getCharPref("mail.accountmanager.accounts");
	
		   var idstr=""; 
			if (accounts) {
			    var accountsArray = accounts.split(",");    
			    for (var x = 0; x < accountsArray.length; x++) {
					var temp1 = _prefs.getCharPref("mail.account." + accountsArray[x] + ".server");
					if (servers.indexOf(temp1)> -1) { 
					try { idstr += _prefs.getCharPref("mail.account." + accountsArray[x] 
							+ ".identities") +",";}
						catch (ex) {}
					}
				}
			}

			var ids = Components.classes["@mozilla.org/messenger/account-manager;1"].
		                  getService(Components.interfaces.nsIMsgAccountManager).allIdentities;	
			var mailIds = "";
			for (var i = 0; i < ids.Count(); ++i) {
				var nextId  = ids.GetElementAt(i).
									QueryInterface (Components.interfaces.nsIMsgIdentity);
					if (idstr.indexOf(nextId.key)> -1) { 			
						try { mailIds += nextId.identityName + ",";}
							catch (ex) {}
					}
			}
			// delete last comma
			mailIds = mailIds.substring(0,mailIds.length-1);

		} else { // 'NON messenger' .. eg.FX etc ...
			try {
				var mailIds = reminderFox_prefsBranch.getCharPref(REMINDER_FOX_MAIL_SENDER);
			} catch (ex) {}
		}
		return mailIds;
	}

	rmFxMsg.getIdentity = function (fromAddress)
	/** ===================================================================== **/	
	/*		checks all non-nntp servers for valid 'fromAddress'
	 * 	returns the 'identity'
	 * 	If not matching 
	 * 		-- not valid mailName --> take first valid identity for that server
	 * 		-- at all, take 'defaultAccount.defaultIdentity'
	 * 
	 * 	in NON 'messenger' just return the 'fromAddress'
	 */
	{  var ids = Components.classes["@mozilla.org/messenger/account-manager;1"].
		                  getService(Components.interfaces.nsIMsgAccountManager).allIdentities;
		if ((fromAddress != null ) &&  (fromAddress != "" )) {
			var returnId = null;
			var xMailAdr ="x";
			var xId = -1;
			for (var i = 0; i < ids.Count(); ++i) {
		
				var nextId  = ids.GetElementAt(i).
									QueryInterface (Components.interfaces.nsIMsgIdentity);
				if ((fromAddress.indexOf(nextId.email) > -1) && (xMailAdr != nextId.email)){
					xMailAdr =nextId.email;
					xId = i;
				}
				if (nextId.identityName == fromAddress) {return nextId;}
			}
		}
	//	return ids.GetElementAt(xId).
	//								QueryInterface (Components.interfaces.nsIMsgIdentity);
	
			// not found at all, return default
		return  rmFxMsg.getAccountMngr().defaultAccount.defaultIdentity;
	}


//////////////////// utilities 'general' ///////////////////////////////////////

function rmFxUtil () { // support different Mail functions   
} 

	rmFxUtil.encodeUTF8	= function (text)
	/** ===================================================================== **/	
	{	return rmFxUtil.convertFromUnicode("UTF-8", text).replace(/(\r\n)|\n/g, "\r\n");
	}
				
	rmFxUtil.convertFromUnicode = function (aCharset, aSrc)
	/** ===================================================================== **/	
	{	var unicodeConverter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"]
                                     .createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
    	unicodeConverter.charset = aCharset;
    	return unicodeConverter.ConvertFromUnicode(aSrc);
	}
	
	rmFxUtil.getIOService = function ()
	/** ===================================================================== **/	
	{	if (rmFxUtil.getIOService.mObject === undefined) {
			rmFxUtil.getIOService.mObject = Components.classes["@mozilla.org/network/io-service;1"]
							.getService(Components.interfaces.nsIIOService2);
		}
		return rmFxUtil.getIOService.mObject;
	}

	rmFxUtil.buildUIDFile = function  (rmFx_UID) 
	/** ===================================================================== **/	
	{	var tempDir = Components.classes["@mozilla.org/file/directory_service;1"]
			.getService(Components.interfaces.nsIProperties)
			.get("TmpD", Components.interfaces.nsIFile);
			
			tempDir.append( "tempMsg" + rmFx_UID );

		return  tempDir.path;
	}

   
	rmFxUtil.readInFileContents = function (tmpFile)
	/** ===================================================================== **/	
	{	var sfile = Components.classes["@mozilla.org/file/local;1"]
				.createInstance(Components.interfaces.nsILocalFile);
		sfile.initWithPath(tmpFile);
	
		try {
			netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
		} catch (e) {
			rmFxCore.PromptAlert("Permission to read file was denied. " + e.name  +  " -- " + e.message);
			return null;
		}
	
		var is = Components.classes["@mozilla.org/network/file-input-stream;1"]
			.createInstance( Components.interfaces.nsIFileInputStream );
		try {
			is.init( sfile,0x01, 00004, null);
		}
		catch ( e ) {
			rmFxCore.PromptAlert("Could not read reminder file: " + e.name  +  " -- " + e.message);
			return null;
		}		
		// Now, read from the stream
		var scriptableStream = Components.classes["@mozilla.org/scriptableinputstream;1"]
		                                 .createInstance(Components.interfaces.nsIScriptableInputStream);
		scriptableStream.init(is);
		var converter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"]
		                          .createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
		converter.charset = "UTF-8";  // The character encoding you want, using UTF-8 here
		
		var chunk = scriptableStream.read(scriptableStream.available());
		scriptableStream.close();
		var input = null;
		try {
			 input = converter.ConvertToUnicode(chunk);
		}
		catch( e ) {
			input = chunk;
		}		
		return input;
	}   
    
  	rmFxUtil.makeMsgFile =	function (content, tempFile)
	/** ====================================================================== **/	
	{	 var sfile = Components.classes["@mozilla.org/file/local;1"]
				.createInstance(Components.interfaces.nsILocalFile);
		sfile.initWithPath(tempFile);

		if (sfile.exists()) {
			sfile.remove(true);
		}
		sfile.create(sfile.NORMAL_FILE_TYPE, 0600);
		var stream = Components.classes['@mozilla.org/network/file-output-stream;1']
				.createInstance(Components.interfaces.nsIFileOutputStream);
		stream.init(sfile, 2, 0x200, false); 		// open as "write only"
		stream.write(content, content.length);
		stream.close();
		return sfile;
	}	

	rmFxUtil.makeMsgFile8 =	function (outputStr, file) {
	/** ====================================================================== **/	
		
	var sfile = Components.classes["@mozilla.org/file/local;1"]
			.createInstance(Components.interfaces.nsILocalFile);
	sfile.initWithPath(file);
	
	var outputStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
		.createInstance( Components.interfaces.nsIFileOutputStream );
	outputStream.init( sfile, 0x04 | 0x08 | 0x20, 420, 0 );
	
	var converter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"]
	                          .createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
	converter.charset = "UTF-8";
	
	var chunk = null;
	try {
		chunk = converter.ConvertFromUnicode(outputStr);
	}
	catch( e ) {
		chunk = outputStr;
	}
	outputStream.write(chunk, chunk.length);	
	
	 var fin = converter.Finish();
	 if (fin.length > 0)
	   outputStream.write(fin, fin.length);
	 outputStream.close();
	 return sfile;
}

	
	rmFxUtil.mailDateTime = function (thisdate, format) 
	/** ===================================================================== **/	
	//  build different date/time formats used with normal mail messages                           
	{	var sDaysOfWeek 	= ["Sun","Mon","Tue","Wed","Thu","Fri","Sat"];
		var sMonths			= ["Jan","Feb","Mar","Apr","May","Jun",
									"Jul","Aug","Sep","Oct","Nov","Dec"];
		var offset 			= thisdate.getTimezoneOffset();
	
		function dVal(val) { 
			if (val < 10) val = "0" + val;
			return val; 
		}
	
		if (format == "mailDate") {		//Fri, 06 Jun 2008 23:47:53 +0200
		var 	s  = sDaysOfWeek[thisdate.getDay()]	+ ", ";
				s += thisdate.getDate() 				+ " ";
				s += sMonths[thisdate.getMonth()] 	+ " ";
				s += thisdate.getFullYear() 			+ " ";
			
				s += dVal(thisdate.getHours())   	+ ":";
				s += dVal(thisdate.getMinutes()) 	+ ":";
				s += dVal(thisdate.getSeconds()) 	+ " ";
		if (offset < 0) {
			offset *= -1;
			s += "+";
		}
		else
			s += "-";
	
		s += dVal(Math.floor (offset / 60));
		s += dVal(Math.floor (offset % 60));
		}
	
		if (format == "mailHeader") {		//Fri Jun 13 20:37:33 2008
		var 	s  = sDaysOfWeek[thisdate.getDay()]	+ " ";
				s += sMonths[thisdate.getMonth()] 	+ " ";
				s += thisdate.getDate() 				+ " ";
			
				s += dVal(thisdate.getHours())   	+ ":";
				s += dVal(thisdate.getMinutes()) 	+ ":";
				s += dVal(thisdate.getSeconds()) 	+ " ";
	
				s += thisdate.getFullYear() 			+ " ";
		}
		return s;
	}

	
	rmFxUtil.dump2Console = function (logString)
	/** ===================================================================== **/	
	{	var rmFx_consoleService = Components.classes["@mozilla.org/consoleservice;1"]
			.getService(Components.interfaces.nsIConsoleService);

	      rmFx_consoleService.logStringMessage("reminderFox: " + logString);
	}	 
	
	
	
	rmFxUtil.setStatus = function (text)  {
	/** ----------------------------------------------------------------------**/
	// Generic function to set 'RmFx Status' ... tribute to g.Tom ;-)

		if (text != "" ){
			var rmFx_consoleService = Components.classes["@mozilla.org/consoleservice;1"]
					.getService(Components.interfaces.nsIConsoleService);
		
			rmFx_consoleService.logStringMessage("reminderFox: " + text);
		}
		try { // if coming from FX to TB will not find element,
				//   the 'rmFx_consoleService' signals the user 
				//   the 'mail' app was used by REMOTE (eg.FX)
				
			var statusTxt = document.getElementById("reminderFox-network-status");			
			statusTxt.setAttribute("value", text);
			if (text != "" ){   
				setTimeout(rmFxUtil.resetStatus,10000);
			}
		} catch (ex){}
}

	rmFxUtil.resetStatus = function ()  {
	/** ----------------------------------------------------------------------**/
	// Generic function to reset 'RmFx Status' 
			var statusTxt = document.getElementById("reminderFox-network-status");			
			statusTxt.setAttribute("value","");   
}
